/* ------------------------------------------------------------------------------------ */
/* Interface 2008N@7                      		                        		*/
/*   iFmain                                          		                		*/
/*   쐬: 2008.05.25                                         		        		*/
/*   쐬: Tachi			                                               				*/
/* ------------------------------------------------------------------------------------ */

/* wb_t@CCN[h   ------------------------------------------------------- */
#include "macrodriver.h"
#include "common.h"
#include "system.h"
#include "port.h"
#include "timer.h"
#include "watchdogtimer.h"
#include "serial.h"
#include "timer_user.h"
#include "serial_user.h"
#include "pcdisp.h"
#include "led.h"
#include "sw.h"

/* }N`   ----------------------------------------------------------------------- */
#define	SANDCLOCK	0								/* cDispModeF v[h			*/
#define	COUNTDOWN	1								/* cDispModeF JEg_E[h	*/              

#define	FINISH_PIC	" (           ><  *********)\r"	/* v̏I摜					*/

/* ֐vg^Cv錾 --------------------------------------------------------------- */
static	void	voSwOperation( void );				/* XCb`쏈					*/
static	void	voTimerWork( void );				/* ^C}쒆					*/

/* 萔`     ----------------------------------------------------------------------- */

/* ϐ`     ----------------------------------------------------------------------- */
char	cDispMode;									/* \[hpϐ					*/
													/* v[hƃJEg_E		*/

/* J֐     ----------------------------------------------------------------------- */

/*======================================================================================**
** mainW[
**    @@ Ȃ
**   ߂l    Ȃ
*/
void main( void )
{
	Led_voLED1( LEDOFF );							/* \LED𗼕Ƃ		*/
	Led_voLED2( LEDOFF );

	voSwOperation();								/* [hݒƃX^[g			*/

													/* @^C}Jn@@				*/
	Pcdisp_voInitClockDisp();						/* oߕ\֌W̏		*/
	Timer_voStartTimer();							/* ^C}X^[g				*/

	voTimerWork();									/* @^C}v@				*/

													/* @^C}@@				*/
	if ( cDispMode == SANDCLOCK ){					/* v[ĥƂ				*/
		Uart_voSendString( FINISH_PIC );			/* | ŏI\`͂ŏ		*/
	}												/* | ꂢɌ					*/

	while( 1 ){										/* [vŏID				*/
		;											/* 肽Ƃ̓Zbg	*/
	}

	/* end */
}


/* ֐     ----------------------------------------------------------------------- */

/*======================================================================================**
** Switch Operation : XCb`̏D[hݒƃ^C}Jn
**    @@ Ȃ
**   ߂l    Ȃ
**             [hݒl cDispMode ɐݒ肷D
*/
static void voSwOperation()
{
	while( Sw_cStartSw() != SW_ON ){				/* X^[gXCb`܂	*/
		if ( Sw_cModeSw() == SW_ON ){				/* | [hXCb`ꂽ		*/
			if ( cDispMode == SANDCLOCK ){			/* | | v[hȂ			*/
				Led_voLED2( LEDON );				/* | | | LED2_				*/
				cDispMode = COUNTDOWN;				/* | | | JEg_E[hɂ	*/
			}
			else{									/* | | JEg_E[hȂ	*/
				Led_voLED2( LEDOFF );				/* | | | LED2				*/
				cDispMode = SANDCLOCK ;				/* | | | v[hɂ			*/
			}
		}
	}

	return;
}

/*======================================================================================**
** TimerWork F ^C}쒆DPCւ̕\ĂԁD͎Ԍv̋󂫎ԂɎsD
**    @@ Ȃ
**             \[hƂ cDispMode QƂ
**   ߂l    Ȃ
*/
static void voTimerWork()
{
	while( Timer_bIsDone() == OFF ){				/* 3v܂				*/
		if ( cDispMode == SANDCLOCK ){				/* | \[hvȂ			*/
			Pcdisp_voSandClock(); 					/* | | v\Ă				*/
		}
		else{										/* | JEg_E[hȂ		*/
			Pcdisp_voCountDown();					/* | | JEg_E\Ă		*/
		}
	}

	return;
}

/* end of file	*/
