/* ------------------------------------------------------------------------------------ */
/* Interface 2008N@7                      		                        		*/
/*   iFPcDisp                                        		                		*/
/*   쐬: 2008.05.25                                         		        		*/
/*   쐬: Tachi			                                               				*/
/* ------------------------------------------------------------------------------------ */

/* wb_t@CCN[h   ------------------------------------------------------- */
#include "common.h" 
#include "timer_user.h"
#include "serial_user.h"

/* }N`   ----------------------------------------------------------------------- */
#define	TOPofRIGHT	15								/* v\̗鍻̊Jnʒu	*/
#define	ENDofRIGHT	25								/* ̈ʒu					*/
#define	TOPofLEFT	4								/* ̍ʂ̏l				*/

													/*            111111111122222222	*/
													/*  0123456789012345678901234567	*/
													/* " (  *********><           )\r";	*/
													/*      ^    ^   ^	*/

static	char	cSndClk[ 30 ];						/* v\pobt@		*/
static	char	cSndPos;							/* 鍻݈̌ʒu				*/
static	char	cSndEnd;							/* ܂ŗʒu				*/
static	char	cSndUpper;							/* ̏ʒu					*/
static	int		iOldTime;							/* O̎ԕۑpD@ݎԂƔr	*/
													/* āCω\XV	*/
static	bool	bSndMove;							/* ̈ړ^C~OptO		*/

/* ֐vg^Cv錾 --------------------------------------------------------------- */

/* 萔`     ----------------------------------------------------------------------- */

/* ϐ`     ----------------------------------------------------------------------- */

/* J֐     ----------------------------------------------------------------------- */

/*======================================================================================**
** InitClockDisp : UARToR̕\֘Aϐ
**    @@ Ȃ
**   ߂l    Ȃ
*/
void Pcdisp_voInitClockDisp()
{
	char	*pcSrc;
	char	*pcDst;
	pcSrc = " (  *********><           )\r";
	pcDst = cSndClk;

	while( *pcSrc != '\0' ){						/* \pzɁCl		*/
		*pcDst = *pcSrc;							/* Rs[D						*/
		pcDst++;
		pcSrc++;
	}
	*pcDst = '\0';									/* ŌNULL̂Yꂸ	*/

	cSndPos   = TOPofRIGHT;							/* ̏ʒu͉Eg̍(?)	*/
	cSndEnd   = ENDofRIGHT;							/* ̗ŏI_͉EgE(?)	*/
	cSndUpper = TOPofLEFT;							/* ̍ŏʂ͍g̍(?)		*/
	iOldTime  = -1;									/* ݎƔr̂ŁCl	*/
													/* 肦ȂlɂĂ			*/
	bSndMove  = OFF;

	Uart_voSendString( "\033[>5h" );				/* ŃJ[\锤Ȃ񂾂	*/
	Uart_voSendString( "\n\r" );					/* \ɃS~ƂȂ̂	*/
													/* sR[h𑗂Ă			*/
	return;
}

/*======================================================================================**
** CountDown : PCւ̃JEg_E\D@lłPWOb猸Z\
**    @@ Ȃ
**   ߂l    Ȃ
*/
void Pcdisp_voCountDown()
{
	char	cTime[ 6 ];								/* \ԕpobt@			*/
	int		iCurTime;								/* ݎԎ擾p					*/

	iCurTime = Timer_iGetCurTime();					/* ݎԂ𓾂					*/
	iCurTime /= 10;									/* Ԃ100msPʂȂ̂10Ŋ	*/
													/* bɂ							*/

	if ( iOldTime != iCurTime ){					/* O񂩂玞Ԃił珈	*/
		iOldTime = iCurTime;						/* | ݎԂۑ					*/
		iCurTime = 180 - iCurTime;					/* | oߎԂc莞Ԃɕϊ		*/

		cTime[ 5 ] = '\0';							/* | ̂܂NULL			*/
		cTime[ 4 ] = '\r';							/* | \J[\s̓Ɉړ	*/
		cTime[ 0 ] = ' ';							/* | J[\Ƃ̂łP	*/
													/* | 						*/

		cTime[ 3 ] = (char)( iCurTime % 10 ) + '0';	/* | P̈ʂ̌						*/

		iCurTime /= 10;	
		cTime[ 2 ] = (char)( iCurTime % 10 ) + '0';	/* | 10̈ʂ̌						*/

		iCurTime /= 10;
		cTime[ 1 ] = (char)( iCurTime % 10 ) + '0';	/* | 100̈ʂ̌					*/

		if ( cTime[ 1 ] == '0' ){					/* | 100̈ʂO			*/
			cTime[ 1 ] = ' ';						/* | | 󔒂ɕύXĕ\Ȃ		*/

			if ( cTime[ 2 ] == '0' ){				/* | | 10̈ʁuvO		*/
				cTime[ 2 ] = ' ';					/* | | | 󔒂ɕύXĕ\Ȃ	*/
			}
		}

		Uart_voSendString( cTime );					/* | uartőM					*/
	}

	return;
}

/*======================================================================================**
** SandClock : v\
**    @@ Ȃ
**   ߂l    Ȃ
*/
void Pcdisp_voSandClock()
{
	int	iCurTime;									/* ݎԎ擾p					*/

	iCurTime = Timer_iGetCurTime();					/* ݎԂ𓾂D					*/

	if ( iCurTime == 0 ){							/* ŏ̂ObpX	*/
		return;										/* return͈ӏƂ邪CC	*/
	}												/* fg[͌₷		*/

	if ( iOldTime != iCurTime ){					/* OĂ΂ꂽƂ玞Ԃo߁H	*/
		if ( ( iCurTime % 200 ) == 0 ){				/* | 20bƂ						*/
			bSndMove = ON;							/* | | 𓮂					*/
		}

		if ( ( iCurTime & 1 ) == 0 ){				/* | b̂Ƃ(200msɂȂ)	*/
			cSndClk[ cSndPos ] = ' ';				/* | | 鍻(Öʒu)	*/
			cSndPos++;								/* | | ̍̈ʒu͂ЂƂE		*/

			if ( cSndEnd < cSndPos ){				/* | | E_	*/
				cSndPos = TOPofRIGHT;				/* | | | ̈ʒu͈ԍɏ	*/

				if ( bSndMove == ON){				/* | | | ̎ړ^C~OȂ	*/
					bSndMove = OFF;					/* | | | | tO		*/

					cSndClk[ cSndUpper ] = ' ';		/* | | | | ̍ЂƂ炵	*/
					cSndUpper++;					/* | | | | ̍ʈʒuړ		*/

					cSndClk[ cSndEnd ] = '*';		/* | | | | E̍𑝂₵			*/
					cSndEnd--;						/* | | | | E̍ʈʒuړ		*/
				}
			}

			cSndClk[ cSndPos ] = '*';				/* | | | 鍻`				*/

			Uart_voSendString( cSndClk );			/* | | | UARTŐVv𑗐M	*/
		}

		iOldTime = iCurTime;						/* | | ݎԂۑ				*/
	}

	return;
}

/* end of file */
